package com.jiuqi.script.rhino;

import java.lang.reflect.Method;
import java.util.HashMap;
import org.mozilla.javascript.JavaAdapter;
import java.util.Map;

public class WrapFactory
{
    private Class facade;
    private Map mmap;
    
    @Deprecated
    public static Object wrap(final Object obj, final Class facade) {
        return new WrapFactory(facade).wrap(obj);
    }
    
    public static Object wrap(final Object obj, final Map mmap) {
        return new LimitedScriptObject(obj, mmap);
    }
    
    public static Object unwrap(final Object obj) throws NoSuchFieldException, IllegalAccessException {
        return JavaAdapter.getAdapterSelf((Class)LimitedScriptObject.class, obj);
    }
    
    public WrapFactory(final Class facade) {
        if (facade == null) {
            throw new NullPointerException("facade参数不能为null");
        }
        this.facade = facade;
    }
    
    protected Map getMethods() {
        if (this.mmap == null) {
            synchronized (this.facade) {
                if (this.mmap != null) {
                    final Map mmap = this.mmap;
                    monitorexit(this.facade);
                    return mmap;
                }
                final Method[] methods = this.facade.getMethods();
                this.mmap = new HashMap();
                for (int i = 0; i < methods.length; ++i) {
                    this.mmap.put(methods[i].getName(), methods[i]);
                }
                monitorexit(this.facade);
            }
        }
        return this.mmap;
    }
    
    public Object wrap(final Object obj) {
        return wrap(obj, this.getMethods());
    }
}
